include("colors.nut")


local tuneMode=0


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


sunset0 <-
{
  VZ=fromRgb(35, 83, 150)
  VH=[1 1 1]
  VG=[0.1, 0.3, 0.5]
  SS=mul(fromRgb(255, 230, 100), 1.5)
  SP=mul(fromRgb(150, 200, 255), 1)
  SO=mul(fromRgb(100, 150, 200), 1)
  CS=mul(fromRgb(255, 220, 100), 2)
  CG=mul([1.0, 1.1, 1.5], 8)
  scale=mul(fromRgb(255, 255, 255), 1)
  sunD=mul([1.0, 0.7, 0.2], 2.0)
  sunL=mul([1.0, 0.7, 0.2], 1.7)
}


sunset2 <-
{
  VZ=fromRgb(10, 50, 200)
  VH=fromRgb(255, 255, 255)
  VG=mul([1.5, 0.5, 0.2], 0.3)
  SS=mul(fromRgb(150, 100,  50), 1)
  SP=mul(fromRgb(  5,  20,  50), 3)
  SO=mul(fromRgb( 20,  50, 150), 0.7)
  CS=mul(fromRgb(255, 150, 50), 1)
  CG=mul([1.0, 2.0, 5.0], 3)
  scale=mul(fromRgb(255, 255, 255), 1)
  sunD=mul([1.0, 0.20, 0.01], 2)
  sunL=mul([1.0, 0.25, 0.01], 2)
}


night3 <-
{
  VZ=mul(fromRgb( 20,  50, 150), 0.5)
  VH=mul(fromRgb( 20,  50, 150), 0.9)
  VG=mul([0.1 0.2 1], 0.3)
  SS=[0.610321 0.44415 0.534592]
  SP=[0.448045 0.4805 0.718613]
  SO=[0.448045 0.4805 0.718613]
  CS=[0 0 0]
  CG=[3 6 15]
  scale=[1 1 1]
  sunD=[0.00430604 0.0269127 0.242215]
  sunL=[0 0 0]
}


night2 <-
{
  VZ=[0.01 0.03 0.15]
  VH=[0.15 0.11 0.27]
  VG=[0.0652276 0.105293 0.40065]
  SO=mul([0.03 0.27 0.60], 1.6)
  SP=mul([0.03 0.27 0.60], 1.6)
  SS=mul([0.23 0.22 0.45], 1.6)
  CS=[0 0 0]
  CG=[3 6 15]
  scale=[1 1 1]
  sunD=[0.00430604 0.0269127 0.242215]
  sunL=[0 0 0]
}


night1 <-
{
  VZ=mul(fromRgb(100, 120, 180), 0.9)
  VH=mul(fromRgb(200, 130, 150), 0.7)
  VG=mul([0.2 0.3 1], 0.5)
  SS=mul(fromRgb(200,  40, 150), 0.5)
  SP=mul(fromRgb( 50, 100, 255), 0.5)
  SO=mul(fromRgb( 50, 100, 255), 0.5)
  CS=mul(fromRgb(255, 150, 50), 0)
  CG=mul([1.0, 2.0, 5.0], 3)
  scale=mul(fromRgb(255, 255, 255), 1)
  sunD=mul(fromRgb( 20,  50, 150), 0.7)
  sunL=mul([1.0, 0.25, 0.01], 0)
}


sunset4 <-
{
  VZ=fromRgb(10, 150, 220)
  VH=fromRgb(255, 255, 255)
  VG=mul([1.5, 0.5, 0.2], 0.3)
  SS=mul(fromRgb(150,  50,  30), 0.2)
  SP=mul(fromRgb( 20, 100, 150), 0.6)
  SO=mul(fromRgb( 20,  80, 150), 0.5)
  CS=mul(fromRgb(255, 150, 50), 1)
  CG=mul([1.0, 4.0, 5.0], 3)
  scale=mul(fromRgb(255, 255, 255), 1)
  sunD=mul([1.0, 0.10, 0.01], 1.8)
  sunL=mul([1.0, 0.25, 0.01], 1.0)
}


midnight <-
{
  VZ=mul(fromRgb( 20,  50, 150), 0.4)
  VH=mul(fromRgb( 20,  50, 150), 0.7)
  VG=mul([0.1 0.2 1], 0.3)
  SS=[1 1 1]
  SO=[1 1 1]
  SP=[1 1 1]
  CS=mul(fromRgb(255, 150, 50), 0)
  CG=mul([1.0, 2.0, 5.0], 3)
  scale=mul(fromRgb(255, 255, 255), 1)
  sunD=mul(fromRgb( 20,  50, 150), 0.7)
  sunL=mul([1.0, 0.25, 0.01], 0)
}


midday <-
{
  VZ=fromRgb(35, 83, 150)
  VH=[1 1 1]
  VG=[0.2, 0.5, 1.5]
  SS=mul([1.05, 1.35, 1.5], 0.66)
  SP=mul([1 1 1], 1)
  SO=mul([1.05, 1.35, 1.5], 0.66)
  CS=mul([20 8 1], 1)
  CG=mul([1.0, 1.1, 1.5], 5)
  scale=mul(fromRgb(255, 255, 255), 1.0)
  sunD=mul([1.0, 0.9, 0.5], 2)
  sunL=mul([1.0, 0.9, 0.5], 2)
}


alarm <-
{
  VZ=fromRgb(255, 255, 255)
  VH=fromRgb(255, 255, 255)
  VG=mul([1.5, 0.5, 0.2], 0.3)
  SS=mul(fromRgb(255,   0,   0), 1)
  SP=mul(fromRgb(  0,   0,   0), 1)
  SO=mul(fromRgb(150,   0,   0), 1)
  CS=mul(fromRgb(255, 0, 0), 1)
  CG=mul([1.0, 2.0, 5.0], 3)
  scale=mul(fromRgb(255, 255, 255), 1)
  sunD=mul([1 0 0], 2)
  sunL=mul([1 0 0], 2)
}


day <-
{
  VZ=fromRgb(35, 83, 150)
  VH=[1 1 1]
  VG=[0.1, 0.3, 0.5]
  SS=mul([1.05, 1.35, 1.5], 0.66)
  SP=mul([1 1 1], 0.66)
  SO=mul([1.05, 1.35, 1.5], 0.66)
  CS=mul([20 8 1], 0.5)
  CG=mul([1.0, 1.1, 1.5], 5)
  scale=mul(fromRgb(220, 255, 255), 1.3)
  sunD=mul([1.0, 0.9, 0.7], 1.5)
  sunL=mul([1.0, 0.9, 0.5], 1.5)
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


sky_table <-
[
    0, midday,
   45, day,
   79, sunset0,
   99, sunset2,
  119, sunset4,
  135, night1,
  145, night2,
  155, night3,
  180, midnight,
]


sky_table.insert(0, sky_table[0]*2-sky_table[2])
sky_table.insert(1, sky_table[4])

sky_table.append(sky_table[sky_table.len()-2]*2-sky_table[sky_table.len()-4])
sky_table.append(sky_table[sky_table.len()-4])


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


function interp_sky(angle, table)
{
  local i
  for (i=2; i<table.len()-6; i+=2) if (angle<=table[i+2]) break;

  local p0=table[i+1]
  local p1=table[i-1]
  local p2=table[i+5]
  local p3=table[i+3]

  local t=(angle-table[i])/(table[i+2]-table[i]).tofloat()

  local ip={}
  foreach (n,v in p0)
  {
    ip[n] <- lerp(v, p3[n], t)  // linear

    /*
    // cubic
    local tp1=binop(binop(p3[n], p1[n], @(x, y) x-y), p0[n], @(x, y) y+x*0.33)
    local tp2=binop(binop(p0[n], p2[n], @(x, y) x-y), p3[n], @(x, y) y+x*0.33)

    local ip1=lerp(p0[n], tp1  , t)
    local ip2=lerp(tp1  , tp2  , t)
    local ip3=lerp(tp2  , p3[n], t)

    local ip4=lerp(ip1, ip2, t)
    local ip5=lerp(ip2, ip3, t)

    ip[n] <- lerp(ip4, ip5, t)
    //*/
  }

  return ip
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


function get_sky_colors(sun_angle)
{
  //local s=sunset2
  //local s=day
  //local s=midday
  //local s=midnight
  //local s=sunset4
//  local s=night
  local s=interp_sky(sun_angle, sky_table)

  /*
    print("{\n")
    foreach (n,v in s)
    {
      print(format("  %s=[%g %g %g]\n", n, v[0], v[1], v[2]))
    }
    print("}\n")
  //*/

  local V0=s.VH
  local VS=binop(binop(s.VZ, s.VH, @(z, h) z-h), s.VG, @(d, g) d*exp(g))
  local VG=s.VG

  local S0=s.SP
  local S1=binop(s.SS, S0, @(x, y) x-y)
  local S2=binop(s.SO, S0, @(x, y) x-y)

  local CS=s.CS

  local sunD=s.sunD

  V0=mul(V0, s.scale)
  VS=mul(VS, s.scale)
  S0=mul(S0, s.scale)
  S1=mul(S1, s.scale)
  S2=mul(S2, s.scale)
  CS=mul(CS, s.scale)

  switch (tuneMode)
  {
    case 1: S0=[1 1 1]; S1=S2=CS=[0 0 0]; break;
    case 2: V0=[1 1 1]; VS=CS=[0 0 0]; break;
    case 3: V0=[1 1 1]; VS=S0=S1=S2=[0 0 0]; break;
  }

  local r=[V0, VS, VG, S0, S1, S2, CS, s.CG, sunD, s.sunL]
  /*
    foreach (i, p in r)
    {
      print(format("sky_colors[%1d]=make4f(", i))
      foreach (v in p) print(format("% ff, ", v))
      print("0);\n")
    }
  //*/
  return r
}
